﻿using System;
using System.Collections.ObjectModel;

namespace Petzold.Phone.EBookReader
{
    public class AuthorInfo : IEquatable<AuthorInfo>, IComparable<AuthorInfo>
    {
        public AuthorInfo()
        {
            this.Creators = new ObservableCollection<string>();
            this.Titles = new ObservableCollection<TitleInfo>();
        }

        public ObservableCollection<string> Creators { protected set; get; }

        public ObservableCollection<TitleInfo> Titles { protected set; get; }

        public override string ToString()
        {
            string compositeAuthor = "";

            if (Creators.Count == 0)
                return "Various or Anonymous";

            for (int i = 0; i < this.Creators.Count; i++)
            {
                compositeAuthor += this.Creators[i];

                if (i != this.Creators.Count - 1)
                    compositeAuthor += "\n";
            }
            return compositeAuthor;
        }

        string ToCompareString()
        {
            return ToString().ToLowerInvariant();
        }

        public bool Equals(AuthorInfo that)
        {
            return this.ToString().Equals(that.ToString(), StringComparison.OrdinalIgnoreCase);
        }

        public int CompareTo(AuthorInfo that)
        {
            return this.ToCompareString().CompareTo(that.ToCompareString());
        }
    }
}
