﻿using System.Collections.Generic;
using System.Xml.Serialization;

namespace Petzold.Phone.EBookReader
{
    public class ChapterInfo
    {
        public ChapterInfo()
        {
            this.Pages = new List<PageInfo>();
        }

        [XmlAttribute(AttributeName = "T")]
        public string Title { set; get; }

        [XmlAttribute(AttributeName = "FP")]
        public int FirstParagraph { set; get; }

        [XmlAttribute(AttributeName = "PC")]
        public int ParagraphCount { set; get; }

        [XmlAttribute(AttributeName = "IF")]
        public bool IsFirstChapter { set; get; }

        [XmlAttribute(AttributeName = "IL")]
        public bool IsLastChapter { set; get; }

        [XmlElement(ElementName = "PG")]
        public List<PageInfo> Pages { set; get; }

        // This is solely for the benefit of ChaptersPage
        [XmlIgnore]
        public bool IsCurrentChapter { set; get; }
    }
}
