﻿using System.Collections.Generic;

namespace Petzold.Phone.EBookReader
{
    public static class StateDictionaryHelper
    {
        public static void SafeAdd(IDictionary<string, object> state, string key, object obj)
        {
            if (obj == null)
                return;

            if (state.ContainsKey(key))
                state[key] = obj;
            else
                state.Add(key, obj);
        }

        public static T SafeGet<T>(IDictionary<string, object> state, string key, T defaultValue) 
        {
            if (state.ContainsKey(key))
                return (T)state[key];

            return defaultValue;
        }

        public static void SafeRemove(IDictionary<string, object> state, string key)
        {
            if (state.ContainsKey(key))
                state.Remove(key);
        }
    }
}
