﻿using System;
using System.Collections.ObjectModel;

namespace Petzold.Phone.EBookReader
{
    public class TitleInfo : IComparable<TitleInfo>
    {
        public TitleInfo()
        {
            this.Titles = new ObservableCollection<string>();
        }

        public ObservableCollection<string> Titles { protected set; get; }

        public int ID { set; get; }

        public override string ToString()
        {
            string compositeTitle = "";

            for (int i = 0; i < this.Titles.Count; i++)
            {
                compositeTitle += this.Titles[i];

                if (i != this.Titles.Count - 1)
                    compositeTitle += "-";
            }
            return compositeTitle;
        }

        string ToCompareToString()
        {
            string strLower = ToString().ToLowerInvariant();

            if (strLower.StartsWith("the "))
                strLower = strLower.Substring(4);

            else if (strLower.StartsWith("an "))
                strLower = strLower.Substring(3);

            else if (strLower.StartsWith("a "))
                strLower = strLower.Substring(2);

            return strLower;
        }

        public int CompareTo(TitleInfo that)
        {
            string thisString = this.ToCompareToString();
            string thatString = that.ToCompareToString();

            int compare = thisString.CompareTo(thatString);

            if (compare == 0)
                return this.ID.CompareTo(that.ID);

            return compare;
        }
    }
}
