﻿using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Phone.Tasks;
using Petzold.Phone.EBookReader;

namespace PhreeBookReader
{
    public partial class AboutControl : UserControl, ITombstonable
    {
        WebBrowserTask webBrowser = new WebBrowserTask();
        EmailComposeTask emailCompose = new EmailComposeTask();
        double scrollOffset = 0;

        public AboutControl()
        {
            InitializeComponent();

            Loaded += (sender, args) => { scrollViewer.ScrollToVerticalOffset(scrollOffset); };
        }

        public void SaveState(string prefix, IDictionary<string, object> state)
        {
            StateDictionaryHelper.SafeAdd(state, prefix + "scrollOffset", scrollViewer.VerticalOffset);   
        }

        public void RestoreState(string prefix, IDictionary<string, object> state)
        {
            scrollOffset = StateDictionaryHelper.SafeGet(state, prefix + "scrollOffset", 0.0);
        }

        void OnHyperlinkButtonClick(object sender, RoutedEventArgs args)
        {
            Button btn = sender as Button;
            webBrowser.URL = btn.Tag as string;
            webBrowser.Show();
        }

        void OnEmailButtonClick(object sender, RoutedEventArgs args)
        {
            emailCompose.To = "cp@charlespetzold.com";
            emailCompose.Subject = "Phree Book Reader";
            emailCompose.Show();
        }
    }
}
