﻿using System;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Petzold.Phone.EBookReader;
using PhreeBookReader.CatalogServiceReference;

namespace PhreeBookReader
{
    public partial class DisplayTitlePage : PhoneApplicationPage
    {
        BookInfo bookInfo;
        string originalDisplayTitle;

        public DisplayTitlePage()
        {
            InitializeComponent();
        }

        // Load BookInfo from file
        protected override void OnNavigatedTo(NavigationEventArgs args)
        {
            // Get book ID from query string
            int bookID = Int32.Parse(this.NavigationContext.QueryString["bookid"]);

            // Load the GutenbergBook object; set to CatalogInfo
            GutenbergBook gutenbergBook = GutenbergBookExtensions.Load(bookID);
            catalogInfo.GutenbergBook = gutenbergBook;

            // Load the BookInfo; set as the DataContext for everything else
            bookInfo = BookInfo.Load(bookID);
            LayoutRoot.DataContext = bookInfo;
            originalDisplayTitle = bookInfo.DisplayTitle;

            base.OnNavigatedTo(args);
        }

        // Save altered BookInfo to file (nothing more needs to be tombstoned)
        protected override void OnNavigatedFrom(NavigationEventArgs args)
        {
            if (bookInfo.DisplayTitle != originalDisplayTitle)
            {
                bookInfo.Save();
            }
            base.OnNavigatedFrom(args);
        }

        void OnDisplayTitleTextChanged(object sender, TextChangedEventArgs args)
        {
            (sender as TextBox).GetBindingExpression(TextBox.TextProperty).UpdateSource();
        }
    }
}